javax.jdo

## Interface JDOQLTypedSubquery<T>

- Type Parameters:
    `T` - (Candidate) type being represented
  All Superinterfaces:
    Serializable

      public interface JDOQLTypedSubquery<T>
      extends Serializable

  Interface for a type-safe subquery, using a fluent API. Users should call methods on the subquery instance and end with a select of what the subquery returns; this returns the expression that they use to link it with the owning query.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `PersistableExpression<T>` | `candidate()` Method to return an expression for the candidate of the subquery.
    `JDOQLTypedSubquery<T>` | `filter(BooleanExpression expr)` Method to set the filter of the query.
    `JDOQLTypedSubquery<T>` | `groupBy(Expression<?>... exprs)` Method to set the grouping(s) for the query.
    `JDOQLTypedSubquery<T>` | `having(Expression<?> expr)` Method to set the having clause of the query.
    `CollectionExpression<?,?>` | `select(CollectionExpression<?,?> expr)` Accessor for the subquery (collection) expression from the subquery.
    `CharacterExpression` | `selectUnique(CharacterExpression expr)` Accessor for the subquery (character) expression from the subquery when the subquery returns a single value.
    `DateExpression` | `selectUnique(DateExpression expr)` Accessor for the subquery (date) expression from the subquery when the subquery returns a single value.
    `DateTimeExpression` | `selectUnique(DateTimeExpression expr)` Accessor for the subquery (datetime) expression from the subquery when the subquery returns a single value.
    `<S> NumericExpression<S>` | `selectUnique(NumericExpression<S> expr)` Accessor for the subquery (numeric) expression from the subquery when the subquery returns a single value.
    `StringExpression` | `selectUnique(StringExpression expr)` Accessor for the subquery (string) expression from the subquery when the subquery returns a single value.
    `TimeExpression` | `selectUnique(TimeExpression expr)` Accessor for the subquery (time) expression from the subquery when the subquery returns a single value.

- - ### Method Detail

    - #### candidate

          PersistableExpression<T> candidate()

      Method to return an expression for the candidate of the subquery. Cast the returned expression to the candidate "Q" type to be able to call methods on it.
      Returns:
        Expression for the candidate

    - #### filter

          JDOQLTypedSubquery<T> filter(BooleanExpression expr)

      Method to set the filter of the query.
      Parameters:
        `expr` - Filter expression
      Returns:
        The query

    - #### groupBy

          JDOQLTypedSubquery<T> groupBy(Expression<?>... exprs)

      Method to set the grouping(s) for the query.
      Parameters:
        `exprs` - Grouping expression(s)
      Returns:
        The query

    - #### having

          JDOQLTypedSubquery<T> having(Expression<?> expr)

      Method to set the having clause of the query.
      Parameters:
        `expr` - Having expression
      Returns:
        The query

    - #### selectUnique

          <S> NumericExpression<S> selectUnique(NumericExpression<S> expr)

      Accessor for the subquery (numeric) expression from the subquery when the subquery returns a single value.
      Type Parameters:
        `S` - numeric type
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### selectUnique

          StringExpression selectUnique(StringExpression expr)

      Accessor for the subquery (string) expression from the subquery when the subquery returns a single value.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### selectUnique

          DateExpression selectUnique(DateExpression expr)

      Accessor for the subquery (date) expression from the subquery when the subquery returns a single value.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### selectUnique

          DateTimeExpression selectUnique(DateTimeExpression expr)

      Accessor for the subquery (datetime) expression from the subquery when the subquery returns a single value.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### selectUnique

          TimeExpression selectUnique(TimeExpression expr)

      Accessor for the subquery (time) expression from the subquery when the subquery returns a single value.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### selectUnique

          CharacterExpression selectUnique(CharacterExpression expr)

      Accessor for the subquery (character) expression from the subquery when the subquery returns a single value.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

    - #### select

          CollectionExpression<?,?> select(CollectionExpression<?,?> expr)

      Accessor for the subquery (collection) expression from the subquery.
      Parameters:
        `expr` - The expression
      Returns:
        Expression for the typesafe query

Copyright © 2005–2022 The Apache Software Foundation. All rights reserved.